function eu_phase_play (replayer, actions, start_index, end_index, replay_times)

	for j=1, start_index-1 do
		replayer:do_action (actions[j])
	end

	for i=1, replay_times do
		for j=start_index, end_index do
			if not actions[j] then
				break
			end
			replayer:do_action (actions[j])
		end
		replayer:set_mouse_offset (i * 5, 0)
		--eu_msgbox ("next replay")
	end
end

eu_keyboard_mapping = {
	["LBUTTON"]	= "\001",
	["RBUTTON"]	= "\002",
	["CANCEL"]	= "\003",
	["MBUTTON"]	= "\004",
	["BACK"]	= "\008",
	["TAB"]		= "\009",
	["CLEAR"]	= "\012",
	["RETURN"]	= "\013",
	["SHIFT"]	= "\016",
	["CONTROL"]	= "\017",
	["MENU"]	= "\018",
	["PAUSE"]	= "\019",
	["CAPITAL"]	= "\020",
	["KANA"]	= "\021",
	["JUNJA"]	= "\023",
	["FINAL"]	= "\024",
	["KANJI"]	= "\025",
	["ESCAPE"]	= "\027",
	["SPACE"]	= "\032",
	["PRIOR"]	= "\033",
	["NEXT"]	= "\034",
	["END"]		= "\035",
	["HOME"]	= "\036",
	["LEFT"]	= "\037",
	["UP"]		= "\038",
	["RIGHT"]	= "\039",
	["DOWN"]	= "\040",
	["SELECT"]	= "\041",
	["PRINT"]	= "\042",
	["EXECUTE"]	= "\043",
	["SNAPSHOT"]	= "\044",
	["INSERT"]	= "\045",
	["DEL"]		= "\046",
	["HELP"]	= "\047",
	["LWIN"]	= "\091",
	["RWIN"]	= "\092",
	["APPS"]	= "\093",
	["SLEEP"]	= "\095",
	["NUM0"]	= "\096",
	["NUM1"]	= "\097",
	["NUM2"]	= "\098",
	["NUM3"]	= "\099",
	["NUM4"]	= "\100",
	["NUM5"]	= "\101",
	["NUM6"]	= "\102",
	["NUM7"]	= "\103",
	["NUM8"]	= "\104",
	["NUM9"]	= "\105",
	["MUL"]		= "\106",
	["ADD"]		= "\107",
	["SEPARATOR"]	= "\108",
	["SUB"]		= "\109",
	["DECIMAL"]	= "\110",
	["DIV"]		= "\111",
	["F1"]		= "\112",
	["F2"]		= "\113",
	["F3"]		= "\114",
	["F4"]		= "\115",
	["F5"]		= "\116",
	["F6"]		= "\117",
	["F7"]		= "\118",
	["F8"]		= "\119",
	["F9"]		= "\120",
	["F10"]		= "\121",
	["F11"]		= "\122",
	["F12"]		= "\123"
}

function eu_keyboard_char (readable)
	readable = string.upper (readable)
	if string.len (readable) > 1 then
		return eu_keyboard_mapping [readable]
	end
	return readable
end

--[[
eu_msgbox ("hot key is running")

for i=1, 10000 do
	eu_sleep(500)
	eu_keyboard_hit ("DOWN" == "DOWN", "W")
	eu_sleep(5000)
	eu_keyboard_hit ("DOWN" == "UP", "W")
end

eu_msgbox ("hot key is ending")
--]]

function eu_keyboard_hit_run (hit_string, key_map)

	for interval, action, key in string.gmatch (hit_string, "(%d+),%s*(%w+),%s*(%w+).-\n") do

		eu_sleep (interval)

		action = string.upper (action)

		if NULL ~= key_map and NULL ~= key_map[key] then
			key = key_map[key]
		end

		eu_keyboard_hit ("DOWN" == action, key)

	end
end

function eu_mouse_button_hit_run (hit_string)

	for interval, action, other_string in string.gmatch (hit_string, "(%d+),%s*(%w+),(.-)\n") do

		-- eu_msgbox ("interval: " .. interval .. " action: " .. action .. " other: " .. other)

		eu_sleep (interval)

		action = string.upper (action)

		if "MOVE" == action then
			x, y = string.match (other_string, "([+-]?%d+),%s*([+-]?%d+)")

			-- eu_msgbox ("x: " .. x .. " y: " .. y)

			old_x, old_y = eu_cursor_get_position ()

			eu_cursor_set_position (old_x + x, old_y + y)

		else
			which = string.match (other_string, "(%w+)")

			-- eu_msgbox ("which: " .. which)

			which = string.upper (which)

			if "DOWN" == action then
				action = true
			else
				action = false
			end

			if "LEFT" == which then
				which = 1
			elseif "MIDDLE" == which then
				which = 2
			elseif "RIGHT" == which then
				which = 3
			else
				which = 0
			end

			eu_mouse_button_hit (action, which)

		end
	end
end

